/*
 ============================================================================
 Name        : dllTest.c
 Author      : 
 Version     :
 Copyright   : Your copyright notice
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
typedef int (*InitializeFunc)();

int test1(void)
{
    char* err = NULL;
    void * fileHandle = dlopen("./libfile.so", RTLD_LAZY);

    if (fileHandle && (err=dlerror()) == NULL)
    {
        InitializeFunc fileFunc = dlsym(fileHandle, "initialize");

        if ((err=dlerror()) == NULL && fileFunc != NULL)
        {
            fileFunc();
        }
        else
        {
            printf("dlsym file error: %s\n", err);
        }
        dlclose(fileHandle);
    }
    else
    {
        printf("fileHandle is NULL: %s\n", err);
    }
    void * blockHandle = dlopen("./libblock.so", RTLD_LAZY);
    if (blockHandle && (err=dlerror()) == NULL)
    {
        InitializeFunc blockFunc = dlsym(blockHandle, "initialize");

        if ((err=dlerror()) == NULL && blockFunc != NULL)
        {
            blockFunc();
        }
        else
        {
            printf("dlsym block error: %s\n", err);
        }
        dlclose(blockHandle);
    }
    else
    {
        printf("blockHandle is NULL: %s\n", err);
    }

	return 0;
}

//extern int initialize();
//int test2()
//{
//    return initialize();
//}

int main()
{
    test1();
//    int i;
//    scanf("%d", &i);
    return 0;
}

